

//import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.util.*;
import java.util.Enumeration.*;
import javax.microedition.pim.*;

/**
 *
 * @author  nameetha
 * @version
 */
public class ContactSearch implements CommandListener  ,ItemStateListener
{
    private Command Back,Clear,NameS,NumS,NetName,NetNum,subsearch;
    private Form form;
    private Display display;
    private String[] allContactLists;
    private Hashtable hashName;
    private Hashtable hashNum;
    private DisplayCanvas canvas;
    private TextField msgTF;
    private int flag;
    private boolean default1;
    private boolean netnamesearch=true;
    private boolean network=false;
    public ContactSearch(Display d)
    {
        
        
        this.display = d;
        Clear = new Command("Clear and default", Command.OK, 5);
        Back = new Command("Back", Command.OK, 1);
        form = new Form("Contacts",null);
        NameS= new Command("Name Search", Command.OK, 1);
        subsearch= new Command("subsearch Search", Command.OK, 5);
        NumS= new Command("Number Search", Command.OK, 2);
        NetName= new Command("Network Name Search", Command.OK, 3);
        NetNum = new Command("Network Number Search", Command.OK, 4);
        hashName = new Hashtable();
        hashNum = new Hashtable();
        msgTF = new TextField(" Search String ", null,256, 0);
        canvas=new DisplayCanvas("contacts",form.getWidth(),form.getHeight()+50);
        flag = 0;
        default1=true;
        form.addCommand(Back);
        form.addCommand(Clear);
        form.addCommand(NameS);
        form.addCommand(NumS);
        form.addCommand(NetName);
        form.addCommand(subsearch);
        form.addCommand(NetNum);
        form.append(msgTF);
        form.append(canvas);
        form.setCommandListener(this);
        form.setItemStateListener(this);
        
    }
    
    
    public void startContactSearch()
    {
        display.setCurrent(form);

        
    }
    
    
    public void netNameRetrieve(final String name , final String source , final String dest )
    {
        
        new Thread(new Runnable()
        {
            public void run()
            {
                Enumeration e1 = hashName.keys();
                String str,result;
                result = "*"+Scattercom.instance.btnet.localName+"%";
                while(e1.hasMoreElements())
                {   
                    str =(String)e1.nextElement();
                    String tmp=str;
                    str=str.toLowerCase();
                    if(str.startsWith(name.toLowerCase()))
                    {
                        System.out.println(tmp);
                        result = result + tmp + ":" + (String)hashName.get(tmp)+ "#*";
                        
                            
                    }
                    else
                    {
                        System.out.println("No match");
                    }
                } 
                Scattercom.instance.btnet.sendString(NetLayer.SIGNAL_CONTACTS_RESPONSE,result,dest,source);
                //netDisplay(result);
                //send the result back
                    
            }
        }).start();
    }
    
    
    public void netNumRetrieve(final String num , final String source , final String dest )
    {
        new Thread(new Runnable()
        {
            public void run()
            {
                Enumeration e1 = hashNum.keys();
                String str,result;
                result = "*"+Scattercom.instance.btnet.localName+"%";
                while(e1.hasMoreElements())
                {   
                    str =(String)e1.nextElement();
                    String tmp=str;
                    if(str.startsWith(num.toLowerCase()))
                    {
                        System.out.println(tmp);
                        result = result + (String)hashNum.get(tmp) + ":" +tmp + "#*";
                    }
                    else
                    {
                        System.out.println("No match");
                    }
                } 
                Scattercom.instance.btnet.sendString(NetLayer.SIGNAL_CONTACTS_RESPONSE,result,dest,source);
                //netDisplay(result);
                //send the result back
                    
            }
        }).start();
    }
    
   
    
    public void netDisplay(final String result)
    {
       new Thread(new Runnable()
        {
           int i,j;
            public void run()
            { 
                i=result.indexOf("%");
                canvas.addResult("user name : "+ result.substring(1,i++));
                 //i = result.indexOf("*");
                for(i=1;i<result.length();i++)
                 {
                     j = result.indexOf("*",i+1);
                     for(int k=i;k<j;k++)
                     {
                         if(result.charAt(k) ==':')
                         {
                             
                             canvas.addResult("Name :"+result.substring(i,k));
                             i = k+1;
                         }
                          
                         if(result.charAt(k) == '#')
                         {
                             canvas.addResult("Number :"+result.substring(i,k));
                             i=k+1;
                         }
                         
                     }
                     
                     i = j;
                 }
                 /*for(i=0;i<result.length();i++)
                 {
                     j = result.indexOf("*",i+1);
                     if(result.charAt(i)==":")
                         
                     canvas.addResult(result.substring(i,j));
                     
                     i = j;
                 }*/
            }
        }).start();
    }
    
    
    public void commandAction(Command c,Displayable d)
    {
        if(c == Back)
        {
           display.setCurrent(Scattercom.instance.profile);
        }
        
        else if(c == Clear)
        {
            //clear canvas
            canvas.clearResults();
            default1=true;
            flag=0;
            
        }
        
        
        else if(c==subsearch)
        {
            default1=false;
        }
        else if (c == NameS) 
        {
            network=false;
             flag = 0;
        }
        else if(c == NumS)
        {
            network=false;
            flag =1;      
        }   
        else if(c == NetName)
        {
             //String msg = msgTF.getString();
            network=true;
                    
            canvas.clearResults();
            canvas.addResult("Network Search Results");
             netnamesearch=true;
             Scattercom.instance.btnet.sendUI(NetLayer.SIGNAL_CONTACTS_NUM_REQUEST);
             //netNameRetrieve(msg); // to all mobiles in network;
             
            //send name to network
        }
        else if(c == NetNum)
        {
            network=true;
            canvas.clearResults();
            canvas.addResult("Network Search Results");
           // String msg = msgTF.getString();
            netnamesearch=false;
             Scattercom.instance.btnet.sendUI(NetLayer.SIGNAL_CONTACTS_NUM_REQUEST);
           // netNumRetrieve(msg);
            //send num to network
        }

    }
    public synchronized  void sentNetworkRequest(String source,String destination)
    {
        if(netnamesearch)
            Scattercom.instance.btnet.sendString(NetLayer.SIGNAL_CONTACTS_NAME_REQUEST,msgTF.getString(),source,destination);
        else
            Scattercom.instance.btnet.sendString(NetLayer.SIGNAL_CONTACTS_NUM_REQUEST,msgTF.getString(),source,destination);
    }
    public void retrieveContacts()
    {
                
        try
        {
            allContactLists = PIM.getInstance().listPIMLists(PIM.CONTACT_LIST);
            if (allContactLists.length == 0)
                canvas.addResult("No contact lists available");
           
        }
        catch(Exception e)
        {
            System.out.println("1");
        }
        
        new Thread(new Runnable()
        {
            
            ContactList clist = null;
            public void run()
            {
                try
                {
                    int j;
                    canvas.clearResults();
                    for(j =0;j<allContactLists.length;j++)
                    {
                                        
                        clist = (ContactList) PIM.getInstance().openPIMList(PIM.CONTACT_LIST, PIM.READ_ONLY, allContactLists[j]);
                        if (clist.isSupportedField(Contact.FORMATTED_NAME)&& clist.isSupportedField(Contact.TEL))
                        {
                            Enumeration items = clist.items();
                            Vector telNumbers = new Vector();
                            while (items.hasMoreElements())
                            {
                                Contact contact = (Contact) items.nextElement();
                                int telCount = contact.countValues(Contact.TEL);
                                int nameCount = contact.countValues(Contact.FORMATTED_NAME);
                                if (telCount > 0 && nameCount > 0)
                                {
                                    String contactName =contact.getString(Contact.FORMATTED_NAME, 0);
                                    String Tel = contact.getString(Contact.TEL, 0);
                                    for (int i = 0; i < telCount; i++)
                                    {
                                        int telAttributes = contact.getAttributes(Contact.TEL, i);
                                        String telNumber = contact.getString(Contact.TEL, i);
                                        String str1;
                                        if (clist.isSupportedAttribute(Contact.TEL,Contact.ATTR_MOBILE))
                                        {
                                            if ((telAttributes & Contact.ATTR_MOBILE) != 0)
                                            {
                                                telNumbers.insertElementAt(telNumber, 0);
                                                hashNum.put(telNumber,contactName);
                                                str1 = (String)hashNum.get(telNumber);
                                                canvas.addResult(telNumber + str1);
                                                
                                            }
                                            else
                                            {
                                                telNumbers.addElement(telNumber);
                                                hashNum.put(telNumber,contactName);
                                                str1 = (String)hashNum.get(telNumber);
                                                canvas.addResult(telNumber + str1);
                                            }
                                        }
                                        else
                                        {
                                            telNumbers.addElement(telNumber);
                                            hashNum.put(telNumber,contactName);
                                            str1 = (String)hashNum.get(telNumber);
                                            canvas.addResult(telNumber + str1);
                                        }
                                    }
                                    for (int i = 0; i < telNumbers.size(); i++)
                                    {
                                        String s;


                                        s = (String)hashName.get(contactName);
                                        
                                        if( s == null)
                                        {
                                            hashName.put(contactName,telNumbers.elementAt(i));
                                            canvas.addResult(contactName+ ": "+ (String)hashName.get(contactName));

                                        }

                                        else
                                        {
                                            s = s + "#" + telNumbers.elementAt(i);
                                            hashName.put(contactName,s);
                                            canvas.addResult(contactName+ ": "+ (String)hashName.get(contactName));

                                        }
                                    }
                                    
                                    telNumbers.removeAllElements();
                                }
                            }
                        }
                    } 
                    System.out.println("contacts indexing over");
                    if (clist != null)
                    {
                        clist.close();
                    }
                }
                catch(Exception e)
                {
                    System.out.println(e.toString());
                }
            }
            
        }).start();  
    }
    
   
    public void itemStateChanged(Item item)
    {
      if(!network)
      { canvas.clearResults();
          if(item==msgTF)
        {
            new Thread(new Runnable()
            {
                public void run()
                {
                  if(!msgTF.getString().equals(""))
                    {
                        String sb1=msgTF.getString();
                        boolean found=false;
                         if(default1==true)
                         {
                            if(flag==0)
                            {
                                Enumeration e1 = hashName.keys();
                                String str;
                                while(e1.hasMoreElements())
                                {   
                                    str =(String)e1.nextElement();
                                    String tmp=str;
                                    str=str.toLowerCase();
                                    if(str.startsWith(sb1.toLowerCase()))
                                    {
                                        System.out.println(tmp);
                                        canvas.addResult("Name: "+ tmp); 
                                        canvas.addResult("Number: "+ (String)hashName.get(tmp));
                                        found=true;
                                    }
                                    else
                                    {
                                        System.out.println("No match");
                                    }
                                } 
                                if(!found)
                                    canvas.addResult("No Match Found"); 
                            }
                            else 
                            {  
                                Enumeration e2 = hashNum.keys();
                                String str;
                                while(e2.hasMoreElements())
                                {   
                                    str =(String)e2.nextElement();
                                    String tmp=str;
                                    str=str.toLowerCase();
                                    if(str.startsWith(sb1.toLowerCase()))
                                    {
                                        System.out.println(tmp);
                                        canvas.addResult("Number: "+ tmp); 
                                        canvas.addResult("Name: "+ (String)hashNum.get(tmp));
                                        found=true;
                                    }
                                    else
                                    {
                                        System.out.println("No match");
                                    }
                                }
                                if(!found)
                                    canvas.addResult("No Match Found"); 
                            }
                         }
                         else
                         {
                            if(flag==0)
                            {
                                Enumeration e1 = hashName.keys();
                                String str;
                                while(e1.hasMoreElements())
                                {   
                                    str =(String)e1.nextElement();
                                    String tmp=str;
                                    str=str.toLowerCase();
                                    if(str.indexOf(sb1.toLowerCase())!=-1)
                                    {
                                        System.out.println(tmp);
                                        canvas.addResult("Name: "+ tmp); 
                                        canvas.addResult("Number: "+ (String)hashName.get(tmp));
                                        found=true;
                                    }
                                    else
                                    {
                                        System.out.println("No match");
                                    }
                                } 
                                if(!found)
                                    canvas.addResult("No Match Found"); 
                            }
                            else 
                            {  
                                Enumeration e2 = hashNum.keys();
                                String str;
                                while(e2.hasMoreElements())
                                {   
                                    str =(String)e2.nextElement();
                                    String tmp=str;
                                    str=str.toLowerCase();
                                    if(str.indexOf(sb1.toLowerCase())!=-1)
                                    {
                                        System.out.println(tmp);
                                        canvas.addResult("Number: "+ tmp); 
                                        canvas.addResult("Name: "+ (String)hashNum.get(tmp));
                                        found=true;
                                    }
                                    else
                                    {
                                        System.out.println("No match");
                                    }
                                } 
                                if(!found)
                                    canvas.addResult("No Match Found"); 
                            }
                         }
                     }
                     else 
                     {
                         canvas.clearResults();
                         canvas.addResult("Enter Search String"); 
                     } 
                 }
            }).start();
         }
      } 
    }   
}    



           