/*
 * filesearchcopy1.java
 *
 * Created on April 1, 2007, 8:15 PM
 */


import javax.microedition.lcdui.*;
import java.util.*;
import java.io.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;

/**
 *
 * @author  Jabeena
 * @version
 */
public class FileSearch
                        implements CommandListener
                                  ,ItemStateListener  
{
  private Display display;
  private static Form form;
  private TextField msgTF;
  private final static String ROOT="/";
  private String currDirName;
  private Hashtable hash;
  private Command back ;
  private Command clear;
  private Command subSearchNet;
  private FileSearchDisplayCanvas canvas;
  private Command subsearch;
  private boolean flag;
  private boolean network=false;
  
  public FileSearch(Display d) 
  {
        this.display = d;
        hash = new Hashtable();
        form = new Form("File Search");
        subsearch = new Command("Substring starts with",Command.OK,2);
        subSearchNet = new Command("Substring Search Net",Command.OK,4);
        
        back = new Command("Back",Command.OK,1);
        clear = new Command("Clear and default",Command.OK,5);
        currDirName=ROOT;     
        msgTF = new TextField("Enter:", null,256, 0);
        flag=true;
        canvas=new FileSearchDisplayCanvas("File Search",form.getWidth(),form.getHeight()+50);
        form.append(msgTF);
        form.append(canvas);
        form.addCommand(back);
        form.addCommand(clear);
        form.addCommand(subsearch);
        form.addCommand(subSearchNet);
        form.setItemStateListener(this);
        form.setCommandListener(this);
  }  


  

  public void startFileSearch()
  {
      if (System.getProperty("microedition.io.file.FileConnection.version") != null)
      {
          display.setCurrent(form);
      }
  }
  
  
    public void addHash()
    {
        new Thread(new Runnable()
        {
            public void run()
            {
            Enumeration e;
            try 
            {
                hash.put("b","b");
                e = FileSystemRegistry.listRoots();
                while (e.hasMoreElements()) 
                {
                     String fileDirName = (String)e.nextElement();
                     if (fileDirName.charAt(fileDirName.length()-1) == '/') 
                     {
                          detectFile(fileDirName);
                     }
                }
            }
            catch(Exception ex)
            { }
                 }
        }).start();
       // /***********removing command index*************/
        }
    
     public void detectFile(final String fileDirName1)
    {
         new Thread(new Runnable()
        {
            public void run()
            {
                Enumeration e1;
                String fileDirName=fileDirName1;
                FileConnection currDir = null;
                hash.put("bc","bc");
                try
                {
                    if(fileDirName.charAt(fileDirName.length()-1) == '/')
                    {
                        hash.put("bcf","bcf");
                        currDir = (FileConnection)Connector.open("file://localhost/" + fileDirName);
                        e1 = currDir.list();
                        while (e1.hasMoreElements()) 
                        {
                            String Name = (String)e1.nextElement();
                            detectFile(fileDirName + Name);   
                        } 
                    }
                    else
                    {       
                        int i = fileDirName.lastIndexOf('/', fileDirName.length()-2);
                        String s;
                        String coll=null;
                        if (i != -1) 
                        {
                            s = fileDirName.substring(i+1,fileDirName.length());
                            if((String)hash.get(s)==null)
                                hash.put(s.toLowerCase(),fileDirName);
                            else
                            {       
                                coll=(String)hash.get(s)+"#"+fileDirName;
                                hash.put(s.toLowerCase(),coll);
                            }  
                        }
                    }
                    return;
                }
                catch(Exception ex)
                {}
            }
        }).start();
    }
     
     
     public void netFileRetrieve(final String name,final String sender,final String reciever )
    {
        
        new Thread(new Runnable()
        {
            public void run()
            {
                Enumeration e1 = hash.keys();
                String str,result;
                result = "*"+Scattercom.instance.btnet.localName+"%";
                while(e1.hasMoreElements())
                {   
                    str =(String)e1.nextElement();
                    String tmp=str;
                    if(str.indexOf(name.toLowerCase())!=-1)
                    {
                        System.out.println(tmp);
                        result = result + tmp + "$" + (String)hash.get(tmp)+ "#*";
                    }
                    else
                    {
                        System.out.println("No match");
                    }
                } 
                Scattercom.instance.btnet.sendString(NetLayer.SIGNAL_FILE_SEARCH_RESPONSE,result,reciever,sender);
                //netDisplay(result);
                //send the result back
                    
            }
        }).start();
    }
     
public void netDisplay(final String result)
    {
       new Thread(new Runnable()
        {
           int i,j;
            public void run()
            { 
                 
                i=result.indexOf("%");
                canvas.addResult("user name : "+ result.substring(1,i++));
                 for(;i<result.length();i++)
                 {
                     j = result.indexOf("*",i+1);
                     for(int k=i;k<j;k++)
                     {
                         if(result.charAt(k) =='$')
                         {
                             
                             canvas.addResult("File :"+result.substring(i,k));
                             i = k+1;
                         }
                          
                         if(result.charAt(k) == '#')
                         {
                             canvas.addResult("Path :"+result.substring(i,k));
                             i=k+1;
                         }
                     }
                     
                     i = j;
                 }
            }
        }).start();
    }


  public void commandAction(Command c, Displayable d) 
  {
        if (c == back)
        {
            display.setCurrent(Scattercom.instance.profile);
        }
        else if( c == clear)
        { 
            canvas.clearResults();
            flag=true;
            
        }
     
        else if(c==subSearchNet)
        {
            network=true;
        canvas.clearResults();
        canvas.addResult("Network Search Results");
        Scattercom.instance.btnet.sendUI(NetLayer.SIGNAL_FILE_SEARCH_REQUEST);
        //netFileRetrieve(msg);
        
      }
      
    
       else if( c == subsearch)
        { 
            network=false;
            flag=false;
        }
    
    
  }
 
    public synchronized  void sentNetworkRequest(String source,String destination)
    {
        Scattercom.instance.btnet.sendString(NetLayer.SIGNAL_FILE_SEARCH_REQUEST,msgTF.getString(),source,destination);
    }
  public void itemStateChanged(Item item) 
  {
      if(!network)
      {canvas.clearResults();
        if(item==msgTF)
        {
          new Thread(new Runnable()
          {
             public void run()
            {
                 if(msgTF.getString().compareTo("")!=0)
                    {
                        String sb1=msgTF.getString();
                        boolean found=false;
                        Enumeration e1 = hash.keys();
                        String str;
                        System.out.println(" subsearch");
                        if(flag==true)
                        {
                        while(e1.hasMoreElements())
                        {   
                            str =(String)e1.nextElement();
                            if(str.indexOf(sb1.toLowerCase())!=-1)
                             {  
                                canvas.addResult("File: "+ str); 
                                canvas.addResult("Path: "+ (String)hash.get(str));
                                found=true;
                            }//if close
                            else//else3
                            {
                                 System.out.println("No match");
                            }//else3 close
                        }  //while close
                         if(!found)//if4
                                canvas.addResult("No Match Found"); 
                        }
                        else
                        {
                            while(e1.hasMoreElements())
                        {   
                            str =(String)e1.nextElement();
                            if(str.startsWith(sb1.toLowerCase()))
                            {
                                canvas.addResult("File: "+ str); 
                                canvas.addResult("Path: "+ (String)hash.get(str));
                                found=true;
                            }//if close
                            else//else3
                            {
                                 System.out.println("No match");
                            }//else3 close
                        }  //while close
                         if(!found)//if4
                                canvas.addResult("No Match Found"); 
                        }
                     }//if 2 close
                 else 
                 {
                    canvas.clearResults();
                    canvas.addResult("Enter Search String"); 
                 } //else 2 close
        
             }
           }).start(); 
        }//if1 close
       
      }//if network   
    }//fn close
} // end of ScrollMBDemo class
